diff --git a/libpurple/purpleprotocolconversation.h b/libpurple/purpleprotocolconversation.h
--- a/libpurple/purpleprotocolconversation.h
+++ b/libpurple/purpleprotocolconversation.h
@@ -37,10 +37,13 @@
 #include "purplemessage.h"
 #include "purpleprotocol.h"
 #include "purpletyping.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_PROTOCOL_CONVERSATION (purple_protocol_conversation_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleProtocolConversation, purple_protocol_conversation,
                     PURPLE, PROTOCOL_CONVERSATION, PurpleProtocol)
 
@@ -91,6 +94,7 @@ struct _PurpleProtocolConversationInterf
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_conversation_send_message_async(PurpleProtocolConversation *protocol, PurpleConversation *conversation, PurpleMessage *message, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -110,6 +114,7 @@ void purple_protocol_conversation_send_m
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_conversation_send_message_finish(PurpleProtocolConversation *protocol, GAsyncResult *result, GError **error);
 
 /**
@@ -132,6 +137,7 @@ gboolean purple_protocol_conversation_se
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_conversation_set_topic_async(PurpleProtocolConversation *protocol, PurpleConversation *conversation, const char *topic, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -151,6 +157,7 @@ void purple_protocol_conversation_set_to
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_conversation_set_topic_finish(PurpleProtocolConversation *protocol, GAsyncResult *result, GError **error);
 
 /**
@@ -165,6 +172,7 @@ gboolean purple_protocol_conversation_se
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleChannelJoinDetails *purple_protocol_conversation_get_channel_join_details(PurpleProtocolConversation *protocol, PurpleAccount *account);
 
 /**
@@ -185,6 +193,7 @@ PurpleChannelJoinDetails *purple_protoco
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_conversation_join_channel_async(PurpleProtocolConversation *protocol, PurpleAccount *account, PurpleChannelJoinDetails *details, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -204,6 +213,7 @@ void purple_protocol_conversation_join_c
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_conversation_join_channel_finish(PurpleProtocolConversation *protocol, GAsyncResult *result, GError **error);
 
 /**
@@ -221,6 +231,7 @@ gboolean purple_protocol_conversation_jo
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_conversation_set_avatar_async(PurpleProtocolConversation *protocol, PurpleConversation *conversation, PurpleAvatar *avatar, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -240,6 +251,7 @@ void purple_protocol_conversation_set_av
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_conversation_set_avatar_finish(PurpleProtocolConversation *protocol, GAsyncResult *result, GError **error);
 
 /**
@@ -254,6 +266,7 @@ gboolean purple_protocol_conversation_se
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_conversation_send_typing(PurpleProtocolConversation *protocol, PurpleConversation *conversation, PurpleTypingState state);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocolfiletransfer.h b/libpurple/purpleprotocolfiletransfer.h
--- a/libpurple/purpleprotocolfiletransfer.h
+++ b/libpurple/purpleprotocolfiletransfer.h
@@ -32,8 +32,11 @@
 
 #include "purplefiletransfer.h"
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_PROTOCOL_FILE_TRANSFER (purple_protocol_file_transfer_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleProtocolFileTransfer,
                     purple_protocol_file_transfer, PURPLE,
                     PROTOCOL_FILE_TRANSFER, PurpleProtocol)
@@ -86,6 +89,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_file_transfer_send_async(PurpleProtocolFileTransfer *protocol, PurpleFileTransfer *transfer, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -103,6 +107,7 @@ void purple_protocol_file_transfer_send_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_file_transfer_send_finish(PurpleProtocolFileTransfer *protocol, GAsyncResult *result, GError **error);
 
 /**
@@ -120,6 +125,7 @@ gboolean purple_protocol_file_transfer_s
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_file_transfer_receive_async(PurpleProtocolFileTransfer *protocol, PurpleFileTransfer *transfer, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -137,6 +143,7 @@ void purple_protocol_file_transfer_recei
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_file_transfer_receive_finish(PurpleProtocolFileTransfer *protocol, GAsyncResult *result, GError **error);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocolim.h b/libpurple/purpleprotocolim.h
--- a/libpurple/purpleprotocolim.h
+++ b/libpurple/purpleprotocolim.h
@@ -33,6 +33,7 @@
 #include "connection.h"
 #include "purpleconversation.h"
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_PROTOCOL_IM (purple_protocol_im_get_type())
 
@@ -44,6 +45,7 @@
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleProtocolIM, purple_protocol_im, PURPLE, PROTOCOL_IM,
                     PurpleProtocol)
 
diff --git a/libpurple/purpleprotocolmanager.h b/libpurple/purpleprotocolmanager.h
--- a/libpurple/purpleprotocolmanager.h
+++ b/libpurple/purpleprotocolmanager.h
@@ -27,6 +27,7 @@
 #include <glib-object.h>
 
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -37,9 +38,13 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
-#define PURPLE_PROTOCOL_MANAGER_DOMAIN (g_quark_from_static_string("purple-protocol-manager"))
+#define PURPLE_PROTOCOL_MANAGER_DOMAIN \
+	g_quark_from_static_string("purple-protocol-manager") \
+	PURPLE_AVAILABLE_MACRO_IN_3_0
 
 #define PURPLE_TYPE_PROTOCOL_MANAGER (purple_protocol_manager_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleProtocolManager, purple_protocol_manager, PURPLE,
                      PROTOCOL_MANAGER, GObject)
 
@@ -61,6 +66,7 @@ G_DECLARE_FINAL_TYPE(PurpleProtocolManag
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef void (*PurpleProtocolManagerForeachFunc)(PurpleProtocol *protocol, gpointer data);
 
 /**
@@ -72,6 +78,7 @@ typedef void (*PurpleProtocolManagerFore
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleProtocolManager *purple_protocol_manager_get_default(void);
 
 /**
@@ -87,6 +94,7 @@ PurpleProtocolManager *purple_protocol_m
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_manager_register(PurpleProtocolManager *manager, PurpleProtocol *protocol, GError **error);
 
 /**
@@ -102,6 +110,7 @@ gboolean purple_protocol_manager_registe
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_manager_unregister(PurpleProtocolManager *manager, PurpleProtocol *protocol, GError **error);
 
 /**
@@ -115,6 +124,7 @@ gboolean purple_protocol_manager_unregis
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleProtocol *purple_protocol_manager_find(PurpleProtocolManager *manager, const gchar *id);
 
 /**
@@ -127,6 +137,7 @@ PurpleProtocol *purple_protocol_manager_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_manager_foreach(PurpleProtocolManager *manager, PurpleProtocolManagerForeachFunc func, gpointer data);
 
 /**
@@ -141,6 +152,7 @@ void purple_protocol_manager_foreach(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_protocol_manager_get_all(PurpleProtocolManager *manager);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocolmedia.h b/libpurple/purpleprotocolmedia.h
--- a/libpurple/purpleprotocolmedia.h
+++ b/libpurple/purpleprotocolmedia.h
@@ -33,6 +33,7 @@
 #include "media.h"
 #include "purpleaccount.h"
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_PROTOCOL_MEDIA (purple_protocol_media_get_type())
 G_DECLARE_INTERFACE(PurpleProtocolMedia, purple_protocol_media, PURPLE,
@@ -98,6 +99,7 @@ struct _PurpleProtocolMediaInterface {
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_media_initiate_session(PurpleProtocolMedia *media, PurpleAccount *account, const gchar *who, PurpleMediaSessionType type);
 
 /**
@@ -113,6 +115,7 @@ gboolean purple_protocol_media_initiate_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleMediaCaps purple_protocol_media_get_caps(PurpleProtocolMedia *media, PurpleAccount *account, const gchar *who);
 
 /**
@@ -132,6 +135,7 @@ PurpleMediaCaps purple_protocol_media_ge
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_media_send_dtmf(PurpleProtocolMedia *protocol_media, PurpleMedia *media, gchar dtmf, guint8 volume, guint8 duration);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocolroomlist.h b/libpurple/purpleprotocolroomlist.h
--- a/libpurple/purpleprotocolroomlist.h
+++ b/libpurple/purpleprotocolroomlist.h
@@ -32,6 +32,7 @@
 #include "connection.h"
 #include "roomlist.h"
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -44,6 +45,7 @@ G_BEGIN_DECLS
  * lists at the protocol level.
  */
 
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleProtocolRoomlist, purple_protocol_roomlist, PURPLE,
                     PROTOCOL_ROOMLIST, PurpleProtocol)
 
@@ -84,6 +86,7 @@ struct _PurpleProtocolRoomlistInterface 
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRoomlist *purple_protocol_roomlist_get_list(PurpleProtocolRoomlist *protocol_roomlist, PurpleConnection *gc);
 
 /**
@@ -96,6 +99,7 @@ PurpleRoomlist *purple_protocol_roomlist
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_roomlist_cancel(PurpleProtocolRoomlist *protocol_roomlist, PurpleRoomlist *list);
 
 /**
@@ -108,6 +112,7 @@ void purple_protocol_roomlist_cancel(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_roomlist_expand_category(PurpleProtocolRoomlist *protocol_roomlist, PurpleRoomlist *list, PurpleRoomlistRoom *category);
 
 /**
@@ -121,6 +126,7 @@ void purple_protocol_roomlist_expand_cat
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 char *purple_protocol_roomlist_room_serialize(PurpleProtocolRoomlist *protocol_roomlist, PurpleRoomlistRoom *room);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocolroster.h b/libpurple/purpleprotocolroster.h
--- a/libpurple/purpleprotocolroster.h
+++ b/libpurple/purpleprotocolroster.h
@@ -33,8 +33,11 @@
 #include "purpleaccount.h"
 #include "purplecontact.h"
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_PROTOCOL_ROSTER (purple_protocol_roster_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleProtocolRoster, purple_protocol_roster, PURPLE,
                     PROTOCOL_ROSTER, PurpleProtocol)
 
@@ -103,6 +106,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_roster_add_async(PurpleProtocolRoster *roster, PurpleAccount *account, PurpleContact *contact, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -121,6 +125,7 @@ void purple_protocol_roster_add_async(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_roster_add_finish(PurpleProtocolRoster *roster, GAsyncResult *result, GError **error);
 
 /**
@@ -144,6 +149,7 @@ gboolean purple_protocol_roster_add_fini
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_roster_update_async(PurpleProtocolRoster *roster, PurpleAccount *account, PurpleContact *contact, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -162,6 +168,7 @@ void purple_protocol_roster_update_async
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_roster_update_finish(PurpleProtocolRoster *roster, GAsyncResult *result, GError **error);
 
 /**
@@ -180,6 +187,7 @@ gboolean purple_protocol_roster_update_f
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_roster_remove_async(PurpleProtocolRoster *roster, PurpleAccount *account, PurpleContact *contact, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -198,6 +206,7 @@ void purple_protocol_roster_remove_async
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_roster_remove_finish(PurpleProtocolRoster *roster, GAsyncResult *result, GError **error);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocolserver.h b/libpurple/purpleprotocolserver.h
--- a/libpurple/purpleprotocolserver.h
+++ b/libpurple/purpleprotocolserver.h
@@ -36,8 +36,11 @@
 #include "purpleaccount.h"
 #include "purplemessage.h"
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_PROTOCOL_SERVER (purple_protocol_server_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleProtocolServer, purple_protocol_server, PURPLE,
                     PROTOCOL_SERVER, PurpleProtocol)
 
@@ -130,6 +133,7 @@ struct _PurpleProtocolServerInterface {
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_set_info(PurpleProtocolServer *protocol_server, PurpleConnection *connection, const gchar *info);
 
 /**
@@ -143,6 +147,7 @@ void purple_protocol_server_set_info(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_get_info(PurpleProtocolServer *protocol_server, PurpleConnection *connection, const gchar *who);
 
 /**
@@ -155,6 +160,7 @@ void purple_protocol_server_get_info(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_set_status(PurpleProtocolServer *protocol_server, PurpleAccount *account, PurpleStatus *status);
 
 /**
@@ -167,6 +173,7 @@ void purple_protocol_server_set_status(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_set_idle(PurpleProtocolServer *protocol_server, PurpleConnection *connection, gint idletime);
 
 /**
@@ -180,6 +187,7 @@ void purple_protocol_server_set_idle(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_change_passwd(PurpleProtocolServer *protocol_server, PurpleConnection *connection, const gchar *old_pass, const gchar *new_pass);
 
 /**
@@ -198,6 +206,7 @@ void purple_protocol_server_change_passw
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_add_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *connection, PurpleBuddy *buddy, PurpleGroup *group, const gchar *message);
 
 /**
@@ -211,6 +220,7 @@ void purple_protocol_server_add_buddy(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_remove_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *connection, PurpleBuddy *buddy, PurpleGroup *group);
 
 /**
@@ -230,6 +240,7 @@ void purple_protocol_server_remove_buddy
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_remove_buddies(PurpleProtocolServer *protocol_server, PurpleConnection *connection, GList *buddies, GList *groups);
 
 /**
@@ -241,6 +252,7 @@ void purple_protocol_server_remove_buddi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_keepalive(PurpleProtocolServer *protocol_server, PurpleConnection *connection);
 
 /**
@@ -255,6 +267,7 @@ void purple_protocol_server_keepalive(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gint purple_protocol_server_get_keepalive_interval(PurpleProtocolServer *protocol_server);
 
 /**
@@ -268,6 +281,7 @@ gint purple_protocol_server_get_keepaliv
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_alias_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *connection, const gchar *who, const gchar *alias);
 
 /**
@@ -282,6 +296,7 @@ void purple_protocol_server_alias_buddy(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_group_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *connection, const gchar *who, const gchar *old_group, const gchar *new_group);
 
 /**
@@ -297,6 +312,7 @@ void purple_protocol_server_group_buddy(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_rename_group(PurpleProtocolServer *protocol_server, PurpleConnection *connection, const gchar *old_name, PurpleGroup *group, GList *moved_buddies);
 
 /**
@@ -309,6 +325,7 @@ void purple_protocol_server_rename_group
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_set_buddy_icon(PurpleProtocolServer *protocol_server, PurpleConnection *connection, PurpleImage *img);
 
 /**
@@ -321,6 +338,7 @@ void purple_protocol_server_set_buddy_ic
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_server_remove_group(PurpleProtocolServer *protocol_server, PurpleConnection *connection, PurpleGroup *group);
 
 /**
@@ -337,6 +355,7 @@ void purple_protocol_server_remove_group
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gint purple_protocol_server_send_raw(PurpleProtocolServer *protocol_server, PurpleConnection *connection, const gchar *buf, gint len);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocolwhiteboard.h b/libpurple/purpleprotocolwhiteboard.h
--- a/libpurple/purpleprotocolwhiteboard.h
+++ b/libpurple/purpleprotocolwhiteboard.h
@@ -31,9 +31,12 @@
 #include <glib-object.h>
 
 #include "purpleaccount.h"
+#include "purpleversion.h"
 #include "purplewhiteboard.h"
 
 #define PURPLE_TYPE_PROTOCOL_WHITEBOARD (purple_protocol_whiteboard_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleProtocolWhiteboard, purple_protocol_whiteboard, PURPLE,
                     PROTOCOL_WHITEBOARD, PurpleProtocol)
 
@@ -82,6 +85,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleWhiteboard *purple_protocol_whiteboard_create(PurpleProtocolWhiteboard *whiteboard, PurpleAccount *account, const gchar *who, gint state);
 
 G_END_DECLS
diff --git a/libpurple/purpleproxyinfo.h b/libpurple/purpleproxyinfo.h
--- a/libpurple/purpleproxyinfo.h
+++ b/libpurple/purpleproxyinfo.h
@@ -26,6 +26,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 /**
  * PurpleProxyType:
  * @PURPLE_PROXY_TYPE_USE_GLOBAL: Use the global proxy information.
@@ -91,6 +93,7 @@ PurpleProxyType purple_proxy_info_get_pr
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_proxy_info_set_hostname(PurpleProxyInfo *info, const gchar *hostname);
 
 /**
@@ -103,6 +106,7 @@ void purple_proxy_info_set_hostname(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_proxy_info_get_hostname(PurpleProxyInfo *info);
 
 /**
diff --git a/libpurple/purpleroomlistroom.h b/libpurple/purpleroomlistroom.h
--- a/libpurple/purpleroomlistroom.h
+++ b/libpurple/purpleroomlistroom.h
@@ -26,6 +26,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_ROOMLIST_ROOM (purple_roomlist_room_get_type())
@@ -48,6 +50,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_DERIVABLE_TYPE(PurpleRoomlistRoom, purple_roomlist_room, PURPLE,
 						 ROOMLIST_ROOM, GObject)
 
@@ -67,6 +70,7 @@ struct _PurpleRoomlistRoomClass {
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRoomlistRoom *purple_roomlist_room_new(const gchar *name, const gchar *description);
 
 /**
@@ -79,6 +83,7 @@ PurpleRoomlistRoom *purple_roomlist_room
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_roomlist_room_get_name(PurpleRoomlistRoom *room);
 
 /**
@@ -91,6 +96,7 @@ const gchar *purple_roomlist_room_get_na
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_roomlist_room_get_description(PurpleRoomlistRoom *room);
 
 /**
@@ -104,6 +110,7 @@ const gchar *purple_roomlist_room_get_de
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_roomlist_room_get_category(PurpleRoomlistRoom *room);
 
 /**
@@ -115,6 +122,7 @@ const gchar *purple_roomlist_room_get_ca
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_roomlist_room_set_category(PurpleRoomlistRoom *room, const gchar *category);
 
 /**
@@ -127,6 +135,7 @@ void purple_roomlist_room_set_category(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 guint purple_roomlist_room_get_user_count(PurpleRoomlistRoom *room);
 
 /**
@@ -138,6 +147,7 @@ guint purple_roomlist_room_get_user_coun
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_roomlist_room_set_user_count(PurpleRoomlistRoom *room, guint user_count);
 
 /**
@@ -150,6 +160,7 @@ void purple_roomlist_room_set_user_count
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_roomlist_room_add_field(PurpleRoomlistRoom *room, const gchar *field, const gchar *value);
 
 /**
@@ -163,6 +174,7 @@ void purple_roomlist_room_add_field(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_roomlist_room_get_field(PurpleRoomlistRoom *room, const gchar *field);
 
 /**
@@ -176,6 +188,7 @@ const gchar *purple_roomlist_room_get_fi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GHashTable *purple_roomlist_room_get_components(PurpleRoomlistRoom *room);
 
 G_END_DECLS
diff --git a/libpurple/purplesavedpresence.h b/libpurple/purplesavedpresence.h
--- a/libpurple/purplesavedpresence.h
+++ b/libpurple/purplesavedpresence.h
@@ -31,6 +31,7 @@
 #include <glib-object.h>
 
 #include "purplepresence.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -49,6 +50,7 @@ G_DECLARE_FINAL_TYPE(PurpleSavedPresence
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GDateTime *purple_saved_presence_get_last_used(PurpleSavedPresence *presence);
 
 /**
@@ -61,6 +63,7 @@ GDateTime *purple_saved_presence_get_las
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_saved_presence_set_last_used(PurpleSavedPresence *presence, GDateTime *last_used);
 
 /**
@@ -73,6 +76,7 @@ void purple_saved_presence_set_last_used
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 guint64 purple_saved_presence_get_use_count(PurpleSavedPresence *presence);
 
 /**
@@ -84,6 +88,7 @@ guint64 purple_saved_presence_get_use_co
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_saved_presence_set_use_count(PurpleSavedPresence *presence, guint64 use_count);
 
 /**
@@ -97,6 +102,7 @@ void purple_saved_presence_set_use_count
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_saved_presence_get_id(PurpleSavedPresence *presence);
 
 /**
@@ -109,6 +115,7 @@ const char *purple_saved_presence_get_id
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_saved_presence_get_name(PurpleSavedPresence *presence);
 
 /**
@@ -121,6 +128,7 @@ const char *purple_saved_presence_get_na
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_saved_presence_set_name(PurpleSavedPresence *presence, const char *name);
 
 /**
@@ -134,6 +142,7 @@ void purple_saved_presence_set_name(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_saved_presence_get_escaped_name(PurpleSavedPresence *presence);
 
 /**
@@ -146,6 +155,7 @@ const char *purple_saved_presence_get_es
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurplePresencePrimitive purple_saved_presence_get_primitive(PurpleSavedPresence *presence);
 
 /**
@@ -157,6 +167,7 @@ PurplePresencePrimitive purple_saved_pre
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_saved_presence_set_primitive(PurpleSavedPresence *presence, PurplePresencePrimitive primitive);
 
 /**
@@ -169,6 +180,7 @@ void purple_saved_presence_set_primitive
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_saved_presence_get_message(PurpleSavedPresence *presence);
 
 /**
@@ -181,6 +193,7 @@ const char *purple_saved_presence_get_me
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_saved_presence_set_message(PurpleSavedPresence *presence, const char *message);
 
 /**
@@ -193,6 +206,7 @@ void purple_saved_presence_set_message(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_saved_presence_get_emoji(PurpleSavedPresence *presence);
 
 /**
@@ -205,6 +219,7 @@ const char *purple_saved_presence_get_em
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_saved_presence_set_emoji(PurpleSavedPresence *presence, const char *emoji);
 
 /**
@@ -219,6 +234,7 @@ void purple_saved_presence_set_emoji(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_saved_presence_equal(PurpleSavedPresence *a, PurpleSavedPresence *b);
 
 G_END_DECLS
diff --git a/libpurple/purplesqlite3.h b/libpurple/purplesqlite3.h
--- a/libpurple/purplesqlite3.h
+++ b/libpurple/purplesqlite3.h
@@ -26,6 +26,8 @@
 #include <glib.h>
 #include <gio/gio.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 /**
@@ -35,7 +37,9 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
-#define PURPLE_SQLITE3_DOMAIN (g_quark_from_static_string("sqlite3"))
+#define PURPLE_SQLITE3_DOMAIN \
+	g_quark_from_static_string("sqlite3") \
+	PURPLE_AVAILABLE_MACRO_IN_3_0
 
 /**
  * PurpleSqlite3:
@@ -50,6 +54,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 #ifdef SQLITE_API
 typedef sqlite3 PurpleSqlite3;
 #else
@@ -68,6 +73,7 @@ typedef gpointer PurpleSqlite3;
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 int purple_sqlite3_get_schema_version(PurpleSqlite3 *db, GError **error);
 
 /**
@@ -109,6 +115,7 @@ int purple_sqlite3_get_schema_version(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_sqlite3_run_migrations_from_strings(PurpleSqlite3 *db, const char *migrations[], GError **error);
 
 /**
@@ -135,6 +142,7 @@ gboolean purple_sqlite3_run_migrations_f
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_sqlite3_run_migrations_from_resources(PurpleSqlite3 *db, const char *path, const char *migrations[], GError **error);
 
 G_END_DECLS
diff --git a/libpurple/purplesqlitehistoryadapter.h b/libpurple/purplesqlitehistoryadapter.h
--- a/libpurple/purplesqlitehistoryadapter.h
+++ b/libpurple/purplesqlitehistoryadapter.h
@@ -28,6 +28,7 @@
 
 #include "purplehistoryadapter.h"
 #include "purplemessage.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -41,6 +42,8 @@ G_BEGIN_DECLS
  */
 
 #define PURPLE_TYPE_SQLITE_HISTORY_ADAPTER (purple_sqlite_history_adapter_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleSqliteHistoryAdapter, purple_sqlite_history_adapter,
                      PURPLE, SQLITE_HISTORY_ADAPTER, PurpleHistoryAdapter)
 
@@ -54,6 +57,7 @@ G_DECLARE_FINAL_TYPE(PurpleSqliteHistory
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleHistoryAdapter *purple_sqlite_history_adapter_new(const gchar *filename);
 
 /**
@@ -66,6 +70,7 @@ PurpleHistoryAdapter *purple_sqlite_hist
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_sqlite_history_adapter_get_filename(PurpleSqliteHistoryAdapter *adapter);
 
 G_END_DECLS
diff --git a/libpurple/purpletags.h b/libpurple/purpletags.h
--- a/libpurple/purpletags.h
+++ b/libpurple/purpletags.h
@@ -30,7 +30,11 @@
 #include <glib.h>
 #include <gio/gio.h>
 
+#include "purpleversion.h"
+
 #define PURPLE_TYPE_TAGS (purple_tags_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleTags, purple_tags, PURPLE, TAGS, GObject)
 
 /**
@@ -56,6 +60,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleTags *purple_tags_new(void);
 
 /**
@@ -74,6 +79,7 @@ PurpleTags *purple_tags_new(void);
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_tags_lookup(PurpleTags *tags, const gchar *name, gboolean *found);
 
 /**
@@ -88,6 +94,7 @@ const gchar *purple_tags_lookup(PurpleTa
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_tags_get(PurpleTags *tags, const gchar *name);
 
 /**
@@ -100,6 +107,7 @@ const gchar *purple_tags_get(PurpleTags 
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_tags_add(PurpleTags *tags, const gchar *tag);
 
 /**
@@ -113,6 +121,7 @@ void purple_tags_add(PurpleTags *tags, c
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_tags_add_with_value(PurpleTags *tags, const char *name, const char *value);
 
 /**
@@ -127,6 +136,7 @@ void purple_tags_add_with_value(PurpleTa
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_tags_remove(PurpleTags *tags, const gchar *tag);
 
 /**
@@ -142,6 +152,7 @@ gboolean purple_tags_remove(PurpleTags *
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_tags_remove_with_value(PurpleTags *tags, const char *name, const char *value);
 
 /**
@@ -154,6 +165,7 @@ gboolean purple_tags_remove_with_value(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 guint purple_tags_get_count(PurpleTags *tags);
 
 /**
@@ -166,6 +178,7 @@ guint purple_tags_get_count(PurpleTags *
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_tags_get_all(PurpleTags *tags);
 
 /**
@@ -180,6 +193,7 @@ GList *purple_tags_get_all(PurpleTags *t
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_tags_get_all_with_name(PurpleTags *tags, const char *name);
 
 /**
@@ -193,6 +207,7 @@ GList *purple_tags_get_all_with_name(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gchar *purple_tags_to_string(PurpleTags *tags, const gchar *separator);
 
 /**
@@ -207,6 +222,7 @@ gchar *purple_tags_to_string(PurpleTags 
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_tag_parse(const char *tag, char **name, char **value);
 
 G_END_DECLS
diff --git a/libpurple/purpletyping.h b/libpurple/purpletyping.h
--- a/libpurple/purpletyping.h
+++ b/libpurple/purpletyping.h
@@ -35,6 +35,7 @@
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef enum {
     PURPLE_TYPING_STATE_NONE,
     PURPLE_TYPING_STATE_TYPING,
